diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/dot11s/hwmp-proactive-regression.cc ns-3.47/src/mesh/test/dot11s/hwmp-proactive-regression.cc
--- ns-3.46/src/mesh/test/dot11s/hwmp-proactive-regression.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/dot11s/hwmp-proactive-regression.cc	2026-02-16 16:08:49.785230600 -0800
@@ -116,6 +116,8 @@
 HwmpProactiveRegressionTest::CreateDevices()
 {
     int64_t streamsUsed = 0;
+    int64_t streamNumber = 0;
+    int64_t streamIncrement = 1000;
     // 1. setup WiFi
     YansWifiPhyHelper wifiPhy;
     // This test suite output was originally based on YansErrorRateModel
@@ -137,16 +139,19 @@
     mesh.SetNumberOfInterfaces(1);
     NetDeviceContainer meshDevices = mesh.Install(wifiPhy, *m_nodes);
     // Five devices, 10 streams per device
-    streamsUsed += mesh.AssignStreams(meshDevices, streamsUsed);
+    streamsUsed = mesh.AssignStreams(meshDevices, streamNumber);
+    streamNumber += streamIncrement;
     NS_TEST_ASSERT_MSG_EQ(streamsUsed, (meshDevices.GetN() * 10), "Stream mismatch");
     // No streams used here, by default, so streamsUsed should not change
-    streamsUsed += wifiChannel.AssignStreams(chan, streamsUsed);
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed, (meshDevices.GetN() * 10), "Stream mismatch");
+    streamsUsed = wifiChannel.AssignStreams(chan, streamNumber);
+    streamNumber += streamIncrement;
+    NS_TEST_ASSERT_MSG_EQ(streamsUsed, 0, "No stream assignments expected for WifiChannel");
 
     // 3. setup TCP/IP
     InternetStackHelper internetStack;
+    internetStack.SetIpv6StackInstall(false);
     internetStack.Install(*m_nodes);
-    streamsUsed += internetStack.AssignStreams(*m_nodes, streamsUsed);
+    internetStack.AssignStreams(*m_nodes, streamNumber);
     Ipv4AddressHelper address;
     address.SetBase("10.1.1.0", "255.255.255.0");
     m_interfaces = address.Assign(meshDevices);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/dot11s/hwmp-proactive-regression.h ns-3.47/src/mesh/test/dot11s/hwmp-proactive-regression.h
--- ns-3.46/src/mesh/test/dot11s/hwmp-proactive-regression.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/dot11s/hwmp-proactive-regression.h	2026-02-16 16:08:49.785230600 -0800
@@ -6,6 +6,9 @@
  * Authors: Kirill Andreev  <andreev@iitp.ru>
  */
 
+#ifndef HWMP_PROACTIVE_REGRESSION_H
+#define HWMP_PROACTIVE_REGRESSION_H
+
 #include "ns3/ipv4-interface-container.h"
 #include "ns3/node-container.h"
 #include "ns3/nstime.h"
@@ -104,3 +107,5 @@
      */
     void HandleReadClient(Ptr<Socket> socket);
 };
+
+#endif // HWMP_PROACTIVE_REGRESSION_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/dot11s/hwmp-reactive-regression.cc ns-3.47/src/mesh/test/dot11s/hwmp-reactive-regression.cc
--- ns-3.46/src/mesh/test/dot11s/hwmp-reactive-regression.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/dot11s/hwmp-reactive-regression.cc	2026-02-16 16:08:49.786230600 -0800
@@ -105,6 +105,8 @@
 HwmpReactiveRegressionTest::CreateDevices()
 {
     int64_t streamsUsed = 0;
+    int64_t streamNumber = 0;
+    int64_t streamIncrement = 1000;
     // 1. setup WiFi
     YansWifiPhyHelper wifiPhy;
     // This test suite output was originally based on YansErrorRateModel
@@ -118,19 +120,22 @@
     // 2. setup mesh
     MeshHelper mesh = MeshHelper::Default();
     mesh.SetStackInstaller("ns3::Dot11sStack");
-    mesh.SetMacType("RandomStart", TimeValue(Seconds(0.1)));
+    mesh.SetMacType("RandomStart", TimeValue(MilliSeconds(100)));
     mesh.SetNumberOfInterfaces(1);
     NetDeviceContainer meshDevices = mesh.Install(wifiPhy, *m_nodes);
     // Six devices, 10 streams per device
-    streamsUsed += mesh.AssignStreams(meshDevices, streamsUsed);
-    NS_TEST_EXPECT_MSG_EQ(streamsUsed, (meshDevices.GetN() * 10), "Stream assignment mismatch");
-    streamsUsed += wifiChannel.AssignStreams(chan, streamsUsed);
+    streamsUsed = mesh.AssignStreams(meshDevices, streamNumber);
+    streamNumber += streamIncrement;
     NS_TEST_EXPECT_MSG_EQ(streamsUsed, (meshDevices.GetN() * 10), "Stream assignment mismatch");
+    streamsUsed = wifiChannel.AssignStreams(chan, streamNumber);
+    streamNumber += streamIncrement;
+    NS_TEST_EXPECT_MSG_EQ(streamsUsed, 0, "No stream assignments expected for WifiChannel");
 
     // 3. setup TCP/IP
     InternetStackHelper internetStack;
+    internetStack.SetIpv6StackInstall(false);
     internetStack.Install(*m_nodes);
-    streamsUsed += internetStack.AssignStreams(*m_nodes, streamsUsed);
+    internetStack.AssignStreams(*m_nodes, streamNumber);
     Ipv4AddressHelper address;
     address.SetBase("10.1.1.0", "255.255.255.0");
     m_interfaces = address.Assign(meshDevices);
@@ -167,7 +172,7 @@
         socket->Send(Create<Packet>(20));
         m_sentPktsCounter++;
         Simulator::ScheduleWithContext(socket->GetNode()->GetId(),
-                                       Seconds(0.5),
+                                       MilliSeconds(500),
                                        &HwmpReactiveRegressionTest::SendData,
                                        this,
                                        socket);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/dot11s/hwmp-reactive-regression.h ns-3.47/src/mesh/test/dot11s/hwmp-reactive-regression.h
--- ns-3.46/src/mesh/test/dot11s/hwmp-reactive-regression.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/dot11s/hwmp-reactive-regression.h	2026-02-16 16:08:49.786230600 -0800
@@ -5,6 +5,10 @@
  *
  * Authors: Kirill Andreev <andreev@iitp.ru>
  */
+
+#ifndef HWMP_REACTIVE_REGRESSION_H
+#define HWMP_REACTIVE_REGRESSION_H
+
 #include "ns3/ipv4-interface-container.h"
 #include "ns3/node-container.h"
 #include "ns3/nstime.h"
@@ -115,3 +119,5 @@
      */
     void HandleReadClient(Ptr<Socket> socket);
 };
+
+#endif // HWMP_REACTIVE_REGRESSION_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/dot11s/hwmp-simplest-regression.cc ns-3.47/src/mesh/test/dot11s/hwmp-simplest-regression.cc
--- ns-3.46/src/mesh/test/dot11s/hwmp-simplest-regression.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/dot11s/hwmp-simplest-regression.cc	2026-02-16 16:08:49.786230600 -0800
@@ -125,6 +125,8 @@
 HwmpSimplestRegressionTest::CreateDevices()
 {
     int64_t streamsUsed = 0;
+    int64_t streamNumber = 0;
+    int64_t streamIncrement = 1000;
     // 1. setup WiFi
     YansWifiPhyHelper wifiPhy;
     YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default();
@@ -134,19 +136,22 @@
     // 2. setup mesh
     MeshHelper mesh = MeshHelper::Default();
     mesh.SetStackInstaller("ns3::Dot11sStack");
-    mesh.SetMacType("RandomStart", TimeValue(Seconds(0.1)));
+    mesh.SetMacType("RandomStart", TimeValue(MilliSeconds(100)));
     mesh.SetNumberOfInterfaces(1);
     NetDeviceContainer meshDevices = mesh.Install(wifiPhy, *m_nodes);
     // Two devices, ten streams per mesh device
-    streamsUsed += mesh.AssignStreams(meshDevices, streamsUsed);
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed, (meshDevices.GetN() * 10), "Stream assignment mismatch");
-    streamsUsed += wifiChannel.AssignStreams(chan, streamsUsed);
+    streamsUsed = mesh.AssignStreams(meshDevices, streamNumber);
+    streamNumber += streamIncrement;
     NS_TEST_ASSERT_MSG_EQ(streamsUsed, (meshDevices.GetN() * 10), "Stream assignment mismatch");
+    streamsUsed = wifiChannel.AssignStreams(chan, streamNumber);
+    streamNumber += streamIncrement;
+    NS_TEST_ASSERT_MSG_EQ(streamsUsed, 0, "No stream assignments expected for WifiChannel");
 
     // 3. setup TCP/IP
     InternetStackHelper internetStack;
+    internetStack.SetIpv6StackInstall(false);
     internetStack.Install(*m_nodes);
-    streamsUsed += internetStack.AssignStreams(*m_nodes, streamsUsed);
+    internetStack.AssignStreams(*m_nodes, streamNumber);
     Ipv4AddressHelper address;
     address.SetBase("10.1.1.0", "255.255.255.0");
     m_interfaces = address.Assign(meshDevices);
@@ -171,7 +176,7 @@
         socket->Send(Create<Packet>(100));
         m_sentPktsCounter++;
         Simulator::ScheduleWithContext(socket->GetNode()->GetId(),
-                                       Seconds(0.05),
+                                       MilliSeconds(50),
                                        &HwmpSimplestRegressionTest::SendData,
                                        this,
                                        socket);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/dot11s/hwmp-simplest-regression.h ns-3.47/src/mesh/test/dot11s/hwmp-simplest-regression.h
--- ns-3.46/src/mesh/test/dot11s/hwmp-simplest-regression.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/dot11s/hwmp-simplest-regression.h	2026-02-16 16:08:49.786230600 -0800
@@ -6,6 +6,9 @@
  * Authors: Kirill Andreev  <andreev@iitp.ru>
  */
 
+#ifndef HWMP_SIMPLEST_REGRESSION_H
+#define HWMP_SIMPLEST_REGRESSION_H
+
 #include "ns3/ipv4-interface-container.h"
 #include "ns3/node-container.h"
 #include "ns3/nstime.h"
@@ -115,3 +118,5 @@
      */
     void HandleReadClient(Ptr<Socket> socket);
 };
+
+#endif // HWMP_SIMPLEST_REGRESSION_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/dot11s/hwmp-target-flags-regression.cc ns-3.47/src/mesh/test/dot11s/hwmp-target-flags-regression.cc
--- ns-3.46/src/mesh/test/dot11s/hwmp-target-flags-regression.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/dot11s/hwmp-target-flags-regression.cc	2026-02-16 16:08:49.786230600 -0800
@@ -143,6 +143,8 @@
 HwmpDoRfRegressionTest::CreateDevices()
 {
     int64_t streamsUsed = 0;
+    int64_t streamNumber = 0;
+    int64_t streamIncrement = 1000;
     // 1. setup WiFi
     YansWifiPhyHelper wifiPhy;
     // This test suite output was originally based on YansErrorRateModel
@@ -160,15 +162,18 @@
     mesh.SetNumberOfInterfaces(1);
     NetDeviceContainer meshDevices = mesh.Install(wifiPhy, *m_nodes);
     // Four devices, ten streams per mac
-    streamsUsed += mesh.AssignStreams(meshDevices, streamsUsed);
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed, (meshDevices.GetN() * 10), "Stream assignment mismatch");
-    streamsUsed += wifiChannel.AssignStreams(chan, streamsUsed);
+    streamsUsed = mesh.AssignStreams(meshDevices, streamNumber);
+    streamNumber += streamIncrement;
     NS_TEST_ASSERT_MSG_EQ(streamsUsed, (meshDevices.GetN() * 10), "Stream assignment mismatch");
+    streamsUsed = wifiChannel.AssignStreams(chan, streamNumber);
+    streamNumber += streamIncrement;
+    NS_TEST_ASSERT_MSG_EQ(streamsUsed, 0, "No stream assignments expected for WifiChannel");
 
     // 3. setup TCP/IP
     InternetStackHelper internetStack;
+    internetStack.SetIpv6StackInstall(false);
     internetStack.Install(*m_nodes);
-    streamsUsed += internetStack.AssignStreams(*m_nodes, streamsUsed);
+    internetStack.AssignStreams(*m_nodes, streamNumber);
     Ipv4AddressHelper address;
     address.SetBase("10.1.1.0", "255.255.255.0");
     m_interfaces = address.Assign(meshDevices);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/dot11s/hwmp-target-flags-regression.h ns-3.47/src/mesh/test/dot11s/hwmp-target-flags-regression.h
--- ns-3.46/src/mesh/test/dot11s/hwmp-target-flags-regression.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/dot11s/hwmp-target-flags-regression.h	2026-02-16 16:08:49.786230600 -0800
@@ -6,6 +6,9 @@
  * Authors: Kirill Andreev  <andreev@iitp.ru>
  */
 
+#ifndef HWMP_TARGET_FLAGS_REGRESSION_H
+#define HWMP_TARGET_FLAGS_REGRESSION_H
+
 #include "ns3/ipv4-interface-container.h"
 #include "ns3/node-container.h"
 #include "ns3/nstime.h"
@@ -139,3 +142,5 @@
      */
     void HandleReadClient(Ptr<Socket> socket);
 };
+
+#endif // HWMP_TARGET_FLAGS_REGRESSION_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/flame/flame-regression.cc ns-3.47/src/mesh/test/flame/flame-regression.cc
--- ns-3.46/src/mesh/test/flame/flame-regression.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/flame/flame-regression.cc	2026-02-16 16:08:49.786230600 -0800
@@ -87,6 +87,8 @@
 FlameRegressionTest::CreateDevices()
 {
     int64_t streamsUsed = 0;
+    int64_t streamNumber = 1;
+    int64_t streamIncrement = 1000;
     // 1. setup WiFi
     YansWifiPhyHelper wifiPhy;
     // This test suite output was originally based on YansErrorRateModel
@@ -100,23 +102,24 @@
     // 2. setup mesh
     MeshHelper mesh = MeshHelper::Default();
     mesh.SetStackInstaller("ns3::FlameStack");
-    mesh.SetMacType("RandomStart", TimeValue(Seconds(0.1)));
+    mesh.SetMacType("RandomStart", TimeValue(MilliSeconds(100)));
     mesh.SetNumberOfInterfaces(1);
     NetDeviceContainer meshDevices = mesh.Install(wifiPhy, *m_nodes);
     // Three devices, eight streams per device
-    streamsUsed += mesh.AssignStreams(meshDevices, streamsUsed);
+    streamsUsed = mesh.AssignStreams(meshDevices, streamNumber);
+    streamNumber += streamIncrement;
     NS_TEST_ASSERT_MSG_EQ(streamsUsed,
                           (meshDevices.GetN() * 8),
                           "Stream assignment unexpected value");
     // No further streams used in the default wifi channel configuration
-    streamsUsed += wifiChannel.AssignStreams(chan, streamsUsed);
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed,
-                          (meshDevices.GetN() * 8),
-                          "Stream assignment unexpected value");
+    streamsUsed = wifiChannel.AssignStreams(chan, streamNumber);
+    streamNumber += streamIncrement;
+    NS_TEST_ASSERT_MSG_EQ(streamsUsed, 0, "No WifiChannel stream usage expected");
     // 3. setup TCP/IP
     InternetStackHelper internetStack;
+    internetStack.SetIpv6StackInstall(false);
     internetStack.Install(*m_nodes);
-    streamsUsed += internetStack.AssignStreams(*m_nodes, streamsUsed);
+    internetStack.AssignStreams(*m_nodes, streamNumber);
     Ipv4AddressHelper address;
     address.SetBase("10.1.1.0", "255.255.255.0");
     m_interfaces = address.Assign(meshDevices);
@@ -163,7 +166,7 @@
         socket->Send(Create<Packet>(20));
         m_sentPktsCounter++;
         Simulator::ScheduleWithContext(socket->GetNode()->GetId(),
-                                       Seconds(1.1),
+                                       MilliSeconds(1100),
                                        &FlameRegressionTest::SendData,
                                        this,
                                        socket);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mesh/test/flame/flame-regression.h ns-3.47/src/mesh/test/flame/flame-regression.h
--- ns-3.46/src/mesh/test/flame/flame-regression.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mesh/test/flame/flame-regression.h	2026-02-16 16:08:49.786230600 -0800
@@ -6,6 +6,9 @@
  * Authors: Kirill Andreev <andreev@iitp.ru>
  */
 
+#ifndef FLAME_REGRESSION_H
+#define FLAME_REGRESSION_H
+
 #include "ns3/ipv4-interface-container.h"
 #include "ns3/node-container.h"
 #include "ns3/nstime.h"
@@ -106,3 +109,5 @@
      */
     void HandleReadClient(Ptr<Socket> socket);
 };
+
+#endif // FLAME_REGRESSION_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mobility/helper/ns2-mobility-helper.cc ns-3.47/src/mobility/helper/ns2-mobility-helper.cc
--- ns-3.46/src/mobility/helper/ns2-mobility-helper.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mobility/helper/ns2-mobility-helper.cc	2026-02-16 16:08:49.787230700 -0800
@@ -49,7 +49,6 @@
 #define NS2_Z_COORD "Z_"
 #define NS2_SETDEST "setdest"
 #define NS2_SET "set"
-#define NS2_NODEID "$node_("
 #define NS2_NS_SCH "$ns_"
 
 /**
@@ -782,8 +781,8 @@
     if (speed > 0)
     {
         // first calculate the time; time = distance / speed
-        double time = std::sqrt(std::pow(xFinalPosition - retval.m_finalPosition.x, 2) +
-                                std::pow(yFinalPosition - retval.m_finalPosition.y, 2)) /
+        double time = std::hypot(xFinalPosition - retval.m_finalPosition.x,
+                                 yFinalPosition - retval.m_finalPosition.y) /
                       speed;
         NS_LOG_DEBUG("at=" << at << " time=" << time);
         if (time == 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mobility/model/position-allocator.cc ns-3.47/src/mobility/model/position-allocator.cc
--- ns-3.46/src/mobility/model/position-allocator.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mobility/model/position-allocator.cc	2026-02-16 16:08:49.788230700 -0800
@@ -605,7 +605,7 @@
     {
         x = m_rv->GetValue(-m_rho, m_rho);
         y = m_rv->GetValue(-m_rho, m_rho);
-    } while (std::sqrt(x * x + y * y) > m_rho);
+    } while (std::hypot(x, y) > m_rho);
 
     x += m_x;
     y += m_y;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mobility/model/steady-state-random-waypoint-mobility-model.cc ns-3.47/src/mobility/model/steady-state-random-waypoint-mobility-model.cc
--- ns-3.46/src/mobility/model/steady-state-random-waypoint-mobility-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mobility/model/steady-state-random-waypoint-mobility-model.cc	2026-02-16 16:08:49.789230600 -0800
@@ -8,6 +8,7 @@
 #include "steady-state-random-waypoint-mobility-model.h"
 
 #include "ns3/double.h"
+#include "ns3/event-id.h"
 #include "ns3/simulator.h"
 #include "ns3/test.h"
 
@@ -131,6 +132,11 @@
     m_helper.Pause();
 
     // calculate the steady-state probability that a node is initially paused
+    // See the discussion in MR 2675 and
+    // Mathai, Moschopoulos and Pederzoli, Rendiconti Del Circolo Matematico Di Palermo,
+    // Serie II, Tomo XLVIII (1999), p. 163.
+    // https://www.researchgate.net/publication/250677777_Random_points_associated_with_rectangles
+
     double expectedPauseTime = (m_minPause + m_maxPause) / 2;
     double a = m_maxX - m_minX;
     double b = m_maxY - m_minY;
@@ -141,7 +147,7 @@
     double expectedTravelTime = 1.0 / 6.0 * (log1 + log2);
     expectedTravelTime +=
         1.0 / 15.0 * ((a * a * a) / (b * b) + (b * b * b) / (a * a)) -
-        1.0 / 15.0 * std::sqrt(a * a + b * b) * ((a * a) / (b * b) + (b * b) / (a * a) - 3);
+        1.0 / 15.0 * std::hypot(a, b) * ((a * a) / (b * b) + (b * b) / (a * a) - 3);
     if (v0 == v1)
     {
         expectedTravelTime /= v0;
@@ -197,7 +203,7 @@
             x2 = m_x2_r->GetValue(0, a);
             y2 = m_y2_r->GetValue(0, b);
             u1 = m_u_r->GetValue(0, 1);
-            r = std::sqrt(((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1)) / (a * a + b * b));
+            r = std::hypot((x2 - x1), (y2 - y1)) / std::hypot(a, b);
             NS_ASSERT(r <= 1);
         }
         double u2 = m_u_r->GetValue(0, 1);
@@ -223,12 +229,9 @@
     NS_ASSERT(m_minY <= destination.y && destination.y <= m_maxY);
     double u = m_u_r->GetValue(0, 1);
     double speed = std::pow(m_maxSpeed, u) / std::pow(m_minSpeed, u - 1);
-    double dx = (destination.x - m_current.x);
-    double dy = (destination.y - m_current.y);
-    double dz = (destination.z - m_current.z);
-    double k = speed / std::sqrt(dx * dx + dy * dy + dz * dz);
-
-    m_helper.SetVelocity(Vector(k * dx, k * dy, k * dz));
+    Vector deltaPos = destination - m_current;
+    double rate = speed / deltaPos.GetLength();
+    m_helper.SetVelocity(rate * deltaPos);
     m_helper.Unpause();
     Time travelDelay = Seconds(CalculateDistance(destination, m_current) / speed);
     m_event =
@@ -245,12 +248,9 @@
     NS_ASSERT(m_minY <= m_current.y && m_current.y <= m_maxY);
     Vector destination = m_position->GetNext();
     double speed = m_speed->GetValue();
-    double dx = (destination.x - m_current.x);
-    double dy = (destination.y - m_current.y);
-    double dz = (destination.z - m_current.z);
-    double k = speed / std::sqrt(dx * dx + dy * dy + dz * dz);
-
-    m_helper.SetVelocity(Vector(k * dx, k * dy, k * dz));
+    Vector deltaPos = destination - m_current;
+    double rate = speed / deltaPos.GetLength();
+    m_helper.SetVelocity(rate * deltaPos);
     m_helper.Unpause();
     Time travelDelay = Seconds(CalculateDistance(destination, m_current) / speed);
     m_event =
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc ns-3.47/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc
--- ns-3.46/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc	2026-02-16 16:08:49.790230800 -0800
@@ -26,7 +26,7 @@
 {
   public:
     SteadyStateRandomWaypointTest()
-        : TestCase("Check steady-state rwp mobility model velocity and position distributions")
+        : TestCase("Check steady-state rwp mobility model speed and position distributions")
     {
     }
 
@@ -91,18 +91,17 @@
 void
 SteadyStateRandomWaypointTest::DistribCompare()
 {
-    double velocity;
+    double speed;
     double sum_x = 0;
     double sum_y = 0;
     double sum_v = 0;
     for (auto i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
     {
         auto model = (*i);
-        velocity =
-            std::sqrt(std::pow(model->GetVelocity().x, 2) + std::pow(model->GetVelocity().y, 2));
+        speed = model->GetVelocity().GetLength();
         sum_x += model->GetPosition().x;
         sum_y += model->GetPosition().y;
-        sum_v += velocity;
+        sum_v += speed;
     }
     double mean_x = sum_x / count;
     double mean_y = sum_y / count;
@@ -110,7 +109,7 @@
 
     NS_TEST_EXPECT_MSG_EQ_TOL(mean_x, 500, 25.0, "Got unexpected x-position mean value");
     NS_TEST_EXPECT_MSG_EQ_TOL(mean_y, 300, 15.0, "Got unexpected y-position mean value");
-    NS_TEST_EXPECT_MSG_EQ_TOL(mean_v, 2.6, 0.13, "Got unexpected velocity mean value");
+    NS_TEST_EXPECT_MSG_EQ_TOL(mean_v, 2.6, 0.13, "Got unexpected speed mean value");
 
     sum_x = 0;
     sum_y = 0;
@@ -119,13 +118,12 @@
     for (auto i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
     {
         auto model = (*i);
-        velocity =
-            std::sqrt(std::pow(model->GetVelocity().x, 2) + std::pow(model->GetVelocity().y, 2));
+        speed = model->GetVelocity().GetLength();
         tmp = model->GetPosition().x - mean_x;
         sum_x += tmp * tmp;
         tmp = model->GetPosition().y - mean_y;
         sum_y += tmp * tmp;
-        tmp = velocity - mean_v;
+        tmp = speed - mean_v;
         sum_v += tmp * tmp;
     }
     double dev_x = std::sqrt(sum_x / (count - 1));
@@ -134,7 +132,7 @@
 
     NS_TEST_EXPECT_MSG_EQ_TOL(dev_x, 230, 10.0, "Got unexpected x-position standard deviation");
     NS_TEST_EXPECT_MSG_EQ_TOL(dev_y, 140, 7.0, "Got unexpected y-position standard deviation");
-    NS_TEST_EXPECT_MSG_EQ_TOL(dev_v, 4.4, 0.22, "Got unexpected velocity standard deviation");
+    NS_TEST_EXPECT_MSG_EQ_TOL(dev_v, 4.4, 0.22, "Got unexpected speed standard deviation");
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mpi/model/granted-time-window-mpi-interface.h ns-3.47/src/mpi/model/granted-time-window-mpi-interface.h
--- ns-3.46/src/mpi/model/granted-time-window-mpi-interface.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mpi/model/granted-time-window-mpi-interface.h	2026-02-16 16:08:49.790230800 -0800
@@ -105,7 +105,7 @@
      * collaborators are private to restrict use.
      * It is not intended for state to be shared.
      */
-    friend ns3::DistributedSimulatorImpl;
+    friend class ns3::DistributedSimulatorImpl;
 
     /**
      * Check for received messages complete
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mpi/model/mpi-interface.h ns-3.47/src/mpi/model/mpi-interface.h
--- ns-3.46/src/mpi/model/mpi-interface.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mpi/model/mpi-interface.h	2026-02-16 16:08:49.791230700 -0800
@@ -93,13 +93,13 @@
      * MPI_COMM_WORLD communicator.
      *
      * For more complex situations, such as embedding ns-3 with other
-     * MPI simulators or libraries, the Enable(MPI_Comm communcicator)
+     * MPI simulators or libraries, the Enable(MPI_Comm communicator)
      * may be used if MPI is initialized externally or if ns-3 needs to
      * be run unique communicator.  For example if there are two
      * parallel simulators and the goal is to run each simulator on a
      * different set of ranks.
      *
-     * @note The `SimulatorImplementationType attribute in
+     * @note The `SimulatorImplementationType` attribute in
      * ns3::GlobalValues must be set before calling Enable()
      *
      * @param pargc number of command line arguments
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/mpi/model/null-message-mpi-interface.h ns-3.47/src/mpi/model/null-message-mpi-interface.h
--- ns-3.46/src/mpi/model/null-message-mpi-interface.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/mpi/model/null-message-mpi-interface.h	2026-02-16 16:08:49.791230700 -0800
@@ -67,8 +67,8 @@
      * collaborators are private to restrict use.
      * It is not intended for state to be shared.
      */
-    friend ns3::RemoteChannelBundle;
-    friend ns3::NullMessageSimulatorImpl;
+    friend class ns3::RemoteChannelBundle;
+    friend class ns3::NullMessageSimulatorImpl;
 
     /**
      * @brief Send a Null Message to across the specified bundle.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/netanim/examples/star-animation.cc ns-3.47/src/netanim/examples/star-animation.cc
--- ns-3.46/src/netanim/examples/star-animation.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/netanim/examples/star-animation.cc	2026-02-16 16:08:49.797230700 -0800
@@ -43,8 +43,8 @@
     uint32_t nSpokes = 8;
     std::string animFile = "star-animation.xml";
     uint8_t useIpv6 = 0;
-    Ipv6Address ipv6AddressBase = Ipv6Address("2001::");
-    Ipv6Prefix ipv6AddressPrefix = Ipv6Prefix(64);
+    auto ipv6AddressBase = Ipv6Address("2001::");
+    auto ipv6AddressPrefix = Ipv6Prefix(64);
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("nSpokes", "Number of spoke nodes to place in the star", nSpokes);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/CMakeLists.txt ns-3.47/src/network/CMakeLists.txt
--- ns-3.46/src/network/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/CMakeLists.txt	2026-02-16 16:08:49.798230600 -0800
@@ -158,6 +158,7 @@
   HEADER_FILES ${header_files}
   LIBRARIES_TO_LINK ${libstats}
   TEST_SOURCES
+    test/address-test.cc
     test/bit-serializer-test.cc
     test/buffer-test.cc
     test/drop-tail-queue-test-suite.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/helper/application-container.h ns-3.47/src/network/helper/application-container.h
--- ns-3.46/src/network/helper/application-container.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/helper/application-container.h	2026-02-16 16:08:49.799230600 -0800
@@ -68,11 +68,10 @@
      * for-loop to run through the Applications
      *
      * @code
-     *   ApplicationContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some Application method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some Application method
+     *   }
      * @endcode
      *
      * @returns an iterator which refers to the first Application in the container.
@@ -89,11 +88,10 @@
      * for-loop to run through the Applications
      *
      * @code
-     *   ApplicationContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some Application method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some Application method
+     *   }
      * @endcode
      *
      * @returns an iterator which indicates an ending condition for a loop.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/helper/net-device-container.h ns-3.47/src/network/helper/net-device-container.h
--- ns-3.46/src/network/helper/net-device-container.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/helper/net-device-container.h	2026-02-16 16:08:49.799230600 -0800
@@ -85,11 +85,10 @@
      * for-loop to run through the NetDevices
      *
      * @code
-     *   NetDeviceContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some NetDevice method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some NetDevice method
+     *   }
      * @endcode
      *
      * @returns an iterator which refers to the first NetDevice in the container.
@@ -106,11 +105,10 @@
      * for-loop to run through the NetDevices
      *
      * @code
-     *   NetDeviceContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some NetDevice method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some NetDevice method
+     *   }
      * @endcode
      *
      * @returns an iterator which indicates an ending condition for a loop.
@@ -159,6 +157,7 @@
      *
      * @param i the index of the requested device pointer.
      * @returns the requested device pointer.
+     * @hidecaller
      */
     Ptr<NetDevice> Get(uint32_t i) const;
 
@@ -167,6 +166,7 @@
      * this container.
      *
      * @param other The NetDeviceContainer to append.
+     * @hidecaller
      */
     void Add(NetDeviceContainer other);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/helper/node-container.h ns-3.47/src/network/helper/node-container.h
--- ns-3.46/src/network/helper/node-container.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/helper/node-container.h	2026-02-16 16:08:49.799230600 -0800
@@ -112,14 +112,14 @@
      * for-loop to run through the Nodes
      *
      * @code
-     *   NodeContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some Node method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some Node method
+     *   }
      * @endcode
      *
      * @returns an iterator which refers to the first Node in the container.
+     * @hidecaller
      */
     Iterator Begin() const;
 
@@ -133,14 +133,14 @@
      * for-loop to run through the Nodes
      *
      * @code
-     *   NodeContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some Node method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some Node method
+     *   }
      * @endcode
      *
      * @returns an iterator which indicates an ending condition for a loop.
+     * @hidecaller
      */
     Iterator End() const;
 
@@ -186,6 +186,7 @@
      *
      * @param i the index of the requested node pointer.
      * @returns the requested node pointer.
+     * @hidecaller
      */
     Ptr<Node> Get(uint32_t i) const;
 
@@ -198,6 +199,7 @@
      * automates that task.
      *
      * @param n The number of Nodes to create
+     * @hidecaller
      */
     void Create(uint32_t n);
 
